﻿using System.Collections;
using UnityEngine;
using UnityEngine.UI;

/// <summary>
/// Class that uses serial communication
/// </summary>
public class ReadSerial : MonoBehaviour
{
  /// <summary>
  /// SerialHandler
  /// </summary>
  public SerialHandler serialHandler;

  /// <summary>
  /// display text instance 
  /// </summary>
  public Text text;

  /// <summary>
  /// The method to be called at start time
  /// </summary>
  void Start()
  {
    // Register OnDataReceived method of this class to OnDataReceived event 
    serialHandler.OnDataReceived += OnDataReceived;
  }

  /// <summary>
  /// OnDataReceived event
  /// </summary>
  /// <param name="readData"></param>
  void OnDataReceived(string readData)
  {
    try
    {
      byte[] data = System.Text.Encoding.ASCII.GetBytes(readData);
      if (data.Length < 2) return;
      float val = (data[0] << 8) + (data[1] & 0Xff);
      // write on the text
      text.text = (val / 100).ToString();
    }
    catch (System.Exception e)
    {
      Debug.LogWarning(e.Message);
    }
  }
}
